// numero di bolle
int nBubbles = 10;
// vettore delle bolle
Bubble[] bobble = {};   

void setup() {
  fullScreen();
  background(255);
  smooth();
  strokeWeight(1);
  fill(150, 50);
  // crea nuove bolle
  newBubbles();
}

void draw() {
  background(255);
  for (int i=0; i < bobble.length; i++) {
    // muovi le bolle
    bobble[i].moveMe();
    // disegna le bolle
    bobble[i].drawMe();
    // disegna le connessioni
    bobble[i].linkMe();
  }
}

// crea nuove bolle
void newBubbles() {
  for (int i=0; i < nBubbles; i++) { 
    bobble = (Bubble[]) append(bobble, new Bubble(bobble.length));
  }
}

// nuove bolle quando rilascio in mouse
void mouseReleased() {
  newBubbles();
}


class Bubble {

  int id; // identificatore univoco
  float x, y; // coordinate del centro
  float radius; // raggio
  color fillcol; // colore del contenuto 
  float alpha; // trasparenza
  float xmove, ymove; // vettore di movimento (direzione e velocità)
  
  // costruisce una buova bolla
  Bubble(int _id) {
    id = _id;
    x = random(width);
    y = random(height);
    radius = random(10, 100); 
    fillcol = color(random(255), random(255), random(255));
    alpha = random(255);
    xmove = random(-2, 2);   
    ymove = random(-2, 2);  
  }
  
  // disegna una bolla
  void drawMe() { 
    noStroke(); 
    fill(fillcol, alpha);
    ellipse(x, y, radius*2, radius*2);
  }
  
  // muovi una bolla
  void moveMe() {
    x += xmove;
    y += ymove;
    // constrolla i limiti: spazio circolare
    if (x > (width + radius))   x = 0 - radius; 
    if (x < (0 - radius))       x = width + radius; 
    if (y > (height + radius))  y = 0 - radius; 
    if (y < (0 - radius))       y = height + radius; 
    // controlla i limiti: spazio chiuso
    // ...
  }
  
  // connetti le bolle
  void linkMe() {
    for (int i = id + 1; i < bobble.length; i++) {
      float dis = dist(x, y, bobble[i].x, bobble[i].y); 
      float radsum = radius + bobble[i].radius; 
      if (dis < radsum) { 
        stroke(0);
        line(x, y, bobble[i].x, bobble[i].y);
      }
    } 
  }
  
}
