/* 
* Disegna una spirale ellittica usando la casualità organica (noise)
*/
float a; // semiasse maggiore dell'ellisse
float b; // semiasse minore dell'ellisse
float alpha; // angolo
float stepa, stepb; // incrementi degli assi
float lastx, lasty, x, y; // coordinate precedenti e correnti
float noi; // rumore di Perlin 
float variance; // varianza degli assi

void setup() {
  size(600, 400); 
  background(255);
  smooth(); 
  stroke(20, 50, 70);
  strokeWeight(5);
  a = 0;
  b = 0;
  stepa = 0.2;
  stepb = 0.1;
  x = width/2;
  y = height/2;
  alpha = 0;
  // seme iniziale scelto in modo casuale
  noi = random(10);
  // assegno la varianza
  variance = 200;
}


void draw() {
  lastx = x;
  lasty = y;  

  // definisco due nuove variabili locali (visibili sono in draw()) per gli assi dell'ellisse
  float mya, myb;
  
  // faccio variare in modo organico gli assi usando la funzione noise()
  mya = a + (noise(noi) - 0.5) * variance;
  myb = b + (noise(noi) - 0.5) * variance;
  
  // faccio variare in modo caotico gli assi usando la funzione random()
  // mya = a + random(___, ___) * variance;
  // myb = b + random(___, ___) * variance;

  x = width/2 +  mya * cos(alpha);
  y = height/2 + myb * sin(alpha);

  line(x, y, lastx, lasty);

  alpha = alpha + radians(1); 
  
  a = a + stepa;
  b = b + stepb;
  
  // incremento il seme del rumore di Perlin
  noi = noi + 0.05;
  
}
