/*  
  Disegno un albero (codice da http://www.generative-gestaltung.de/code)
 * KEYS
 * 1-9                 : livello della ricorsione
*/

// livello della ricorsione
int recursionLevel = 6;
// raggio iniziale
float startRadius = 200;

void setup() {
  size(800, 600);
  smooth();
  noFill();
  strokeCap(PROJECT);
}

void draw() {

  background(255);
  // sposta l'origine al centro del canvas
  translate(width/2, height/2);
  // rotate(radians(180));
  // disegna ricorsivamente l'albero
  drawTree(0, 0, startRadius, recursionLevel);


}

// disegna l'albero
void drawTree(float x, float y, float radius, int level) {

  // se il livello è maggiore di 0 disegno l'albero
  if (level > 0) {
    // disegno un arco di 180 gradi
    strokeWeight(level*2);
    stroke(0, 130, 164, 100);
    noFill();
    arc(x, y, radius*2, radius*2, -PI, 0);
  
    // disegno un punto al centro dell'arco
    fill(0);
    noStroke();
    ellipse(x, y, level*1.5, level*1.5);

    // disegno il ramo sinistro
    drawTree(x-radius, y+radius/2, radius/2, level-1);

    // disegno il ramo destro
    drawTree(x+radius, y+radius/2, radius/2, level-1);
  }
}


// imposto un nuovo livello da tastiera
void keyReleased() {  
  // converti un carattere ASCII in un numero
  int k = int(key) - 48;
  if (k>=0 && k<=9) {
    recursionLevel = k;
  }
}
